#include <string>
#include <iostream>

using namespace std;


int M,N;
char arr[101][101];

void draw(int x, int y, char c){
	if(x >= 0 && y >= 0 && x < M && y < M)
		arr[x][y] = c;
}

void printAll(){
	
	for (int i = 0 ; i < M ; i++)
		cout << "*";
	cout << "**\n";
	for (int j = M-1; j >= 0; j--){
		cout << "*";
		for ( int i = 0; i<M; i++ )
			cout << arr[i][j];
		cout << "*\n";
	}
	for (int i = 0 ; i < M ; i++)
		cout << "*";
	cout << "**\n\n";
}
	
int main(){
	ios_base::sync_with_stdio(false);	
	
	while(cin >> M >> N){
		
		for ( int i = 0 ; i < M; i++)
			for ( int j = 0 ; j < M ; j++)
				arr[i][j]='.';
		
		for (int i = 0; i < N ; i++){
			int s, x, y;
			cin >> s >> x >> y;
			//cout << s << ' '  << x << ' ' << y << endl;
			if (s == 0) {
				draw(x-1, y, '_');
				draw(x,   y, 'o');
				draw(x+1, y, '_');
			}
			else {
				draw(x-1, y, '_');
				draw(x,   y, '|');
				draw(x+1, y, '_');
				
				for (int j=1;j <= s; j++) {
					draw(x-1, y + j, '/');
					draw(x,   y + j, '|');
					draw(x+1, y + j, '\\');
				}
				draw(x, y + s + 1, '^');
			}	
		}
		
		printAll();

	}

		
	return 0;
}
