#include <string>
#include <iostream>
#include <queue>
using namespace std;

int numbers[5100];
int start[5100];
int length[5100];

int findMax(int j) {
	int max = j;
	while (--j >= 0) {
		if (length[j] > max)
			max = j;
	}
	return max;
}


int main(){
	ios_base::sync_with_stdio(false);	
	
	int n;
	
	while (cin >> n) {
		
		for ( int i = 0; i < n; i++) {
			cin >> numbers[i];
		}
		
		start[0] = -1;
		length[0] = 0;
		
		for (int i = 1; i < n; ++i) {
			int j = i - 1;
			int max = findMax(j);
			if (max == 0) {
				start[i] = -1;
				length[i] = 0;
				while (j-- >= 0) {
					if (numbers[i] == numbers[j]) {
						start[i] = j;
						length[i] = 1;
						break;
					}
				}
			} else {
				int j = max;
				while (j-- >= 0) {
					if (numbers[j] == numbers[i]) {
						length[i] = length[max] + 1;
						start[i] = j;
					}
				}
			}
		}
		
		for (int i = 0; i < n; ++i)
			cout << length[i] << " ";
			
			cout << endl;
		}
		
		return 0;
}
